VERSION 5.00
Begin VB.UserControl ColorSelector 
   BackColor       =   &H00C0C0C0&
   BackStyle       =   0  'Transparent
   ClientHeight    =   3525
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5820
   ScaleHeight     =   3525
   ScaleWidth      =   5820
   ToolboxBitmap   =   "ColorSelector.ctx":0000
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   285
      Index           =   2
      Left            =   180
      ScaleHeight     =   285
      ScaleWidth      =   855
      TabIndex        =   5
      Top             =   750
      Width           =   855
      Begin VB.Label lblColor 
         Alignment       =   2  'Center
         BackColor       =   &H00FF0000&
         BorderStyle     =   1  'Fixed Single
         Caption         =   "0"
         ForeColor       =   &H00FFFFFF&
         Height          =   285
         Index           =   2
         Left            =   0
         TabIndex        =   6
         Top             =   0
         Width           =   855
      End
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   285
      Index           =   1
      Left            =   180
      ScaleHeight     =   285
      ScaleWidth      =   855
      TabIndex        =   4
      Top             =   450
      Width           =   855
      Begin VB.Label lblColor 
         Alignment       =   2  'Center
         BackColor       =   &H0000FF00&
         BorderStyle     =   1  'Fixed Single
         Caption         =   "0"
         Height          =   285
         Index           =   1
         Left            =   0
         TabIndex        =   7
         Top             =   0
         Width           =   855
      End
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00FFFFFF&
      BorderStyle     =   0  'None
      Height          =   285
      Index           =   0
      Left            =   180
      ScaleHeight     =   285
      ScaleWidth      =   855
      TabIndex        =   3
      Top             =   150
      Width           =   855
      Begin VB.Label lblColor 
         Alignment       =   2  'Center
         BackColor       =   &H000000FF&
         BorderStyle     =   1  'Fixed Single
         Caption         =   "0"
         Height          =   285
         Index           =   0
         Left            =   0
         TabIndex        =   8
         Top             =   0
         Width           =   855
      End
   End
   Begin VB.HScrollBar hsbColor 
      Height          =   285
      Index           =   2
      LargeChange     =   25
      Left            =   1050
      Max             =   255
      TabIndex        =   2
      Top             =   750
      Width           =   1980
   End
   Begin VB.HScrollBar hsbColor 
      Height          =   285
      Index           =   1
      LargeChange     =   25
      Left            =   1050
      Max             =   255
      TabIndex        =   1
      Top             =   450
      Width           =   1980
   End
   Begin VB.HScrollBar hsbColor 
      Height          =   285
      Index           =   0
      LargeChange     =   25
      Left            =   1050
      Max             =   255
      TabIndex        =   0
      Top             =   150
      Width           =   1980
   End
End
Attribute VB_Name = "ColorSelector"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
'Default Property Values:
Const m_def_RedComponent = 0
Const m_def_GreenComponent = 0
Const m_def_BlueComponent = 0
'Property Variables:
Dim m_RedComponent As Byte
Dim m_GreenComponent As Byte
Dim m_BlueComponent As Byte
'Event Declarations:
Event ColorChanged(ByVal ColorComponent As csColorComponentConstants) 'MappingInfo=hsbColor(0),hsbColor,0,Change

Public Enum csColorComponentConstants
   csRed = 0
   csGreen = 1
   csBlue = 2
End Enum

Public Enum csBackstyleConstants
   csOpaque = 1
   csTransparent = 0
End Enum

Public Enum csBorderStyleConstants
   csFixed = 1
   csNone = 0
End Enum

'This value is set to true before we change the Value property
'of the scrollbar controls programmatically. The Change event
'of the scrollbars is not executed if this variable is set to true
Private m_bScrollbar As Boolean

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
   Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
   UserControl.Enabled() = New_Enabled
   
   hsbColor(csRed).Enabled = New_Enabled
   hsbColor(csGreen).Enabled = New_Enabled
   hsbColor(csBlue).Enabled = New_Enabled
   
   PropertyChanged "Enabled"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=lblColor(0),lblColor,0,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
   Set Font = lblColor(csRed).Font
End Property

Public Property Set Font(ByVal New_Font As Font)
   
   Set lblColor(csRed).Font = New_Font
   Set lblColor(csGreen).Font = New_Font
   Set lblColor(csBlue).Font = New_Font
   
   PropertyChanged "Font"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As csBorderStyleConstants
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
   BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As csBorderStyleConstants)
   UserControl.BorderStyle() = New_BorderStyle
   PropertyChanged "BorderStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackStyle
Public Property Get BackStyle() As csBackstyleConstants
Attribute BackStyle.VB_Description = "Indicates whether a Label or the background of a Shape is transparent or opaque."
   BackStyle = UserControl.BackStyle
End Property

Public Property Let BackStyle(ByVal New_BackStyle As csBackstyleConstants)
   UserControl.BackStyle() = New_BackStyle
   PropertyChanged "BackStyle"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,0,0,0
Public Property Get RedComponent() As Byte
Attribute RedComponent.VB_Description = "Returns/Sets the red component of the RGB color"
   RedComponent = m_RedComponent
End Property

Public Property Let RedComponent(ByVal New_RedComponent As Byte)
   m_RedComponent = New_RedComponent
   
   'refresh usercontrol's backcolor with the new RGB value
   UserControl.BackColor = RGB(m_RedComponent, m_GreenComponent, m_BlueComponent)
   UserControl.Refresh
   
   'read the new values into the scrollbars
   hsbColor(csRed).Value = New_RedComponent
   
   PropertyChanged "RedComponent"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,0,0,0
Public Property Get GreenComponent() As Byte
Attribute GreenComponent.VB_Description = "Returns/Sets the green component of the RGB color"
   GreenComponent = m_GreenComponent
End Property

Public Property Let GreenComponent(ByVal New_GreenComponent As Byte)
   m_GreenComponent = New_GreenComponent
   
   'refresh usercontrol's backcolor with the new RGB value
   UserControl.BackColor = RGB(m_RedComponent, m_GreenComponent, m_BlueComponent)
   UserControl.Refresh
   
   'read the new values into the scrollbars
   hsbColor(csGreen).Value = New_GreenComponent
   
   PropertyChanged "GreenComponent"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=1,0,0,0
Public Property Get BlueComponent() As Byte
Attribute BlueComponent.VB_Description = "Returns/Sets the blue component of the RGB color"
   BlueComponent = m_BlueComponent
End Property

Public Property Let BlueComponent(ByVal New_BlueComponent As Byte)
   m_BlueComponent = New_BlueComponent
   
   'refresh usercontrol's backcolor with the new RGB value
   UserControl.BackColor = RGB(m_RedComponent, m_GreenComponent, m_BlueComponent)
   UserControl.Refresh
   
   'read the new values into the scrollbars
   hsbColor(csBlue).Value = New_BlueComponent
   
   PropertyChanged "BlueComponent"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get RGBColor() As OLE_COLOR
Attribute RGBColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
   RGBColor = UserControl.BackColor
End Property

Public Property Let RGBColor(ByVal New_RGBColor As OLE_COLOR)
   
   'raise an error if the developer selected a system color
   If Sgn(New_RGBColor) = -1 Then
      If UserControl.Ambient.UserMode = False Then
         MsgBox "RGBColor property can't be a system color", _
         vbExclamation, "Invalid Property Value"
      End If
      Exit Property
   End If
   'refresh usercontrol's backcolor with the new RGB value
   UserControl.BackColor() = New_RGBColor
   UserControl.Refresh
   
   'extract RGB values into private members
   ExtractRGBValues m_RedComponent, m_GreenComponent, m_BlueComponent, CLng(New_RGBColor)
   
   'read new values into scrollbars
   m_bScrollbar = True
   hsbColor(csRed) = m_RedComponent
   hsbColor(csGreen) = m_GreenComponent
   hsbColor(csBlue) = m_BlueComponent
   m_bScrollbar = False

   lblColor(csRed).Caption = m_RedComponent
   lblColor(csGreen).Caption = m_GreenComponent
   lblColor(csBlue).Caption = m_BlueComponent
   
   PropertyChanged "RGBColor"
End Property

Private Sub hsbColor_Change(Index As Integer)
   
   'check if the event was fired by code
   If m_bScrollbar Then Exit Sub
   
   'read scrollbar values into the private members and labels
   m_RedComponent = hsbColor(csRed).Value
   m_GreenComponent = hsbColor(csGreen).Value
   m_BlueComponent = hsbColor(csBlue).Value
   
   lblColor(csRed).Caption = m_RedComponent
   lblColor(csGreen).Caption = m_GreenComponent
   lblColor(csBlue).Caption = m_BlueComponent
   
   'refresh usercontrol's backcolor with the new RGB value
   UserControl.BackColor = RGB(m_RedComponent, m_GreenComponent, m_BlueComponent)
   UserControl.Refresh
   
   'raise ColorChanged event with the proper argument
   RaiseEvent ColorChanged(Index)

End Sub

Private Sub hsbColor_Scroll(Index As Integer)
   hsbColor_Change Index
End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
   m_RedComponent = m_def_RedComponent
   m_GreenComponent = m_def_GreenComponent
   m_BlueComponent = m_def_BlueComponent
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

   UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
   
   Set lblColor(0).Font = PropBag.ReadProperty("Font", Ambient.Font)
   Set lblColor(1).Font = PropBag.ReadProperty("Font", Ambient.Font)
   Set lblColor(2).Font = PropBag.ReadProperty("Font", Ambient.Font)
   
   UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
   UserControl.BackStyle = PropBag.ReadProperty("BackStyle", 1)
   
   m_RedComponent = PropBag.ReadProperty("RedComponent", m_def_RedComponent)
   m_GreenComponent = PropBag.ReadProperty("GreenComponent", m_def_GreenComponent)
   m_BlueComponent = PropBag.ReadProperty("BlueComponent", m_def_BlueComponent)
   
   RGBColor = RGB(m_RedComponent, m_GreenComponent, m_BlueComponent)
   
   UserControl.BackColor = PropBag.ReadProperty("RGBColor", &H8000000F)

End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

   Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
   
   Call PropBag.WriteProperty("Font", lblColor(0).Font, Ambient.Font)
   
   Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 0)
   Call PropBag.WriteProperty("BackStyle", UserControl.BackStyle, 1)
   
   Call PropBag.WriteProperty("RedComponent", m_RedComponent, m_def_RedComponent)
   Call PropBag.WriteProperty("GreenComponent", m_GreenComponent, m_def_GreenComponent)
   Call PropBag.WriteProperty("BlueComponent", m_BlueComponent, m_def_BlueComponent)
   
   Call PropBag.WriteProperty("RGBColor", UserControl.BackColor, &H8000000F)

End Sub

Private Sub ExtractRGBValues(ByRef R As Byte, ByRef G As Byte, ByRef B As Byte, ByVal RGB As Long)
   
   R = RGB \ 65536
   G = (RGB Mod 65536) \ 256
   B = ((RGB Mod 65536) Mod 256)
   
End Sub

Public Sub ShowAboutBox()
Attribute ShowAboutBox.VB_UserMemId = -552
   frmAbout.Show vbModal
   Set frmAbout = Nothing
End Sub

